/*
 * Copyright (C) 2004-2012 Geometer Plus <contact@geometerplus.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include <unistd.h>

#include <tqapplication.h>
#include <tqcursor.h>
#include <tqwidget.h>
#include <tqpainter.h>

#include "ZLTQtProgressDialog.h"
#include "ZLTQtUtil.h"

ZLTQtProgressDialog::ZLTQtProgressDialog(const ZLResourceKey &key) : ZLProgressDialog(key), myWaitMessage(0) {
}

void ZLTQtProgressDialog::run(ZLRunnable &runnable) {
	ZLTQtWaitMessage waitMessage(messageText());
	myWaitMessage = &waitMessage;
	runnable.run();
	myWaitMessage = 0;
}

void ZLTQtProgressDialog::setMessage(const std::string &message) {
	if (myWaitMessage == 0) {
		return;
	}

	myWaitMessage->myLabelText = ::qtString(message);
	myWaitMessage->repaint();
	TQFontMetrics metrics = myWaitMessage->fontMetrics();
	const int w = metrics.width(myWaitMessage->myLabelText) + 20;
	const int h = metrics.height() + 20;
	myWaitMessage->resize(w, h);
	tqApp->processEvents();
}

ZLTQtWaitMessage::ZLTQtWaitMessage(const std::string &message) : TQWidget(0, 0, WStyle_Splash), myLabelText(::qtString(message)) {
	TQWidget *main = tqApp->mainWidget();
	if (main != 0) {
		myCursorIsStored = true;
		myStoredCursor = main->cursor();
		main->setCursor(TQt::waitCursor);
	} else {
		myCursorIsStored = false;
	}
	setCursor(TQt::waitCursor);

	tqApp->processEvents();

	if (main == 0) {
		main = TQApplication::desktop();
	}
	TQPoint position = main->pos();
	TQFontMetrics metrics = fontMetrics();
	const int w = metrics.width(myLabelText) + 20;
	const int h = metrics.height() + 20;
	resize(1, 1);
	show();
	setGeometry(
		position.x() + (main->width() - w) / 2,
		position.y() + (main->height() - h) / 2,
		w, h
	);

	tqApp->processEvents();
	for (int i = 0; i < 6; ++i) {
		usleep(5000);
		tqApp->processEvents();
	}
}

ZLTQtWaitMessage::~ZLTQtWaitMessage() {
	if (myCursorIsStored) {
		TQWidget *main = tqApp->mainWidget();
		if (main != 0) {
			main->setCursor(myStoredCursor);
		}
	}
}

void ZLTQtWaitMessage::paintEvent(TQPaintEvent *event) {
	TQPainter painter;
	painter.begin(this);
	painter.drawText(10, fontMetrics().height() - fontMetrics().descent() + 10, myLabelText);
	painter.end();
}
